<?php

define('IN_FORUM', true);
define('BB_ROOT', './');
require(BB_ROOT .'common.php');

$user->session_start();

$topic_id = (int) request_var('t', '0');
if(!$topic_id) message_die(GENERAL_MESSAGE, 'NO TOPIC_ID!!!');

if(!$row = CACHE('bb_cache')->get("lenta-$topic_id"))
{
$row = DB()->fetch_row("SELECT pt.post_html
		FROM ". BB_BT_TORRENTS ." tr
			LEFT JOIN ". BB_TOPICS ." t ON(tr.topic_id = t.topic_id)
			LEFT JOIN ". BB_POSTS_HTML ." pt ON(pt.post_id = tr.post_id)
		WHERE t.topic_id  = $topic_id");
CACHE('bb_cache')->set("lenta-$topic_id", $row, 300);
}

if(!$row) message_die(GENERAL_MESSAGE, 'NO TOPIC!!!');

preg_match_all('/<var class="postImg postImgAligned img-(.*?)" title="(.*?)">&#10;<\/var>/', $row['post_html'], $poster, PREG_SET_ORDER);
preg_match_all('/<var class="postImg" title="(.*?)">&#10;<\/var>/', $row['post_html'], $poster2, PREG_SET_ORDER);
preg_match_all('/<a href="(.*?)" .*? class="highslide">/', $row['post_html'], $poster3, PREG_SET_ORDER);

$url = '';
if(isset($poster[0][2]))
{
	$url = $poster[0][2];
}
elseif(isset($poster2[0][1]))
{
	$url = $poster2[0][1];
}
elseif(isset($poster3[0][1]))
{
	$url = $poster3[0][1];
}

$filetype = substr(strrchr($url, '.'), 1);
$filename = 'thumb_'.$topic_id.'.'.$filetype;
$no_poster_url = 'styles/images/no-poster.png'; //  -.
$no_poster = '<img border="0" src="styles/images/no-poster.png" style="width: 105px; height: 150px; float: left;" />'; //  -.
$folder = 'data/thumb/'; //  
$thumb_file = $folder . $filename;

//     
if (@fopen($thumb_file, "r"))
{
	switch ($filetype)
	{
		case 'jpg':
		case 'jpeg':
			header('Content-type: image/jpeg');
			header('Content-Disposition: filename='. $filename);
		  break;
		case 'png':
			header('Content-type: image/png');
			header('Content-Disposition: filename='. $filename);
		  break;
		case 'gif':
			header('Content-type: image/gif');
			header('Content-Disposition: filename='. $filename);
		  break;
	}
	header('Cache-Control: public,max-age=86400');
	readfile($thumb_file); //
	exit;
}
else
{
	//    
	if (@fopen($url, "r"))
	{
		//  
		@list($poster_width, $poster_height) = getimagesize($url);

	    if(!$poster_width || !$poster_height) //  
	    {
	    	header('Content-type: image/png');
	    	header('Content-Disposition: filename=no-poster.png');
			readfile($no_poster);
	    }
	    else
	    {
		    @list($poster_width, $poster_height) = getimagesize($url);

		    if(!$poster_width && !$poster_height) //  
		    {
		    	header('Content-type: image/png');
		    	header('Content-Disposition: filename=no-poster.png');
				readfile($no_poster);
		    }

		    // 
		    switch ($filetype)
		    {
		    	case 'jpg':
				case 'jpeg':
					$poster = ImageCreateFromJPEG($url);
				  break;
				case 'png':
					$poster = ImageCreateFromPNG($url);
				  break;
				case 'gif':
					$poster = ImageCreateFromGIF($url);
				  break;
		    }

		    $max_width = 105; //  

			$thumb_width = $max_width;
			$thumb_height = ($poster_height*$max_width)/$poster_width;

			if(($poster_width > $max_width))
			{
				$thumb = imagecreatetruecolor($thumb_width, $thumb_height);

				//   PNG,  
				imagealphablending($thumb, false);
				imagesavealpha($thumb, true);

				imagecopyresampled($thumb, $poster, 0, 0, 0, 0, $thumb_width, $thumb_height, $poster_width, $poster_height);
			}
			else
			{
				$thumb = $poster;
			}

		    // 
		    switch($filetype)
		    {
		    	case "jpg":
		    	case "jpeg":
					header('Content-type: image/jpeg');
					header('Content-Disposition: filename='. $filename);
			    	ImageJPEG($thumb, $thumb_file, 100);
					break;
				case "png":
				    header("Content-type: image/png");
				    header('Content-Disposition: filename='. $filename);
					ImagePNG($thumb, $thumb_file);
					break;
				case "gif":
				    header("Content-type: image/gif");
				    header('Content-Disposition: filename='. $filename);
					ImageGIF($thumb, $thumb_file);
					break;
			}
			//
			imagedestroy($thumb);
			imagedestroy($poster);
			//
			readfile($thumb_file);
			exit;
		}
	}
	else
	{
		header('Content-type: image/png');
		header('Content-Disposition: filename=no-poster.png');
		header('Cache-Control: public,max-age=86400');
		readfile($no_poster_url);
	}
}
?>